import uuid

from IPython.core.display import display
from IPython.display import HTML, Javascript
import ipywidgets.widgets as widgets

from escape.utils.widgets.base import EscapeObjectLayout
from escape.utils.widgets.x3dtpl import X3D_TEMPLATE



class ShapeLayout(EscapeObjectLayout):
    
    def __init__(self, *args, **kwargs):
        super(ShapeLayout, self).__init__(*args, **kwargs)
        self._initialized=False
        self._uid=''
    
    def init_center(self, **kwargs):
        out = widgets.Output()
        return out
    
    def update(self, *args):
        if not self._initialized:
            shape = self.escobj.to_x3d()
            self._uid = str(uuid.uuid4())
            out = X3D_TEMPLATE.format(shape=shape, uid=self._uid)
            with self.center:
                display(HTML(out))
            self._initialized=True
        else:
            shape = self.escobj.to_x3d()
            display(
                Javascript(
                    """
                   var container = document.getElementById("{uid}");
                    container.innerHTML = "{shape}";
                    """.format(shape=shape.replace('\r', '').replace('\n', ''), uid=self._uid)
                    )
                )
            
            
            
            
            
